/*//////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  Copyright 1994-1999, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//      Ionel Daniel Stroe 
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~xmdv
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  XmdvTool Development Team: <matt@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT */

#include <stdio.h>
#include "x.h"

#define	NCL	2*M

char		line[2*M][512];

void main()
{
	int	i, n, id, pid, id1, id2, flag = 1;
	char	line[NCL][512], crt[512];

	puts(gets(crt));			/*	header line	*/
	sscanf(crt, "%d", &n);

	for (i=0; i<n; i++) gets(line[i]);

	while (flag)	/*      bubble sort -- the array almost sorted	*/
	{
		flag = 0;
		for (i=1; i<n; i++)
		{
			sscanf(line[i-1], "%d", &id1);
			sscanf(line[i], "%d", &id2);
			if (id1 < id2)
			{
				strcpy(crt, line[i-1]);
				strcpy(line[i-1], line[i]);
				strcpy(line[i], crt);
				flag = 1;
			}
		}
	}

	for (i=0; i<n; i++)
	{
		sscanf(line[i], "%d %d", &id, &pid);
		printf("%9d %9d ", n-id-1, pid == -1 ? -1 : n-pid-1);
		puts(line[i] + 20);
	}
}
